Index: /XIOS/dev/branch_yushan_merged/src/client_client_dht_template_impl.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/client_client_dht_template_impl.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/client_client_dht_template_impl.hpp	(revision 1134)
@@ -10,9 +10,13 @@
 #include "utils.hpp"
 #include "mpi_tag.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios
 {
 template<typename T, typename H>
-CClientClientDHTTemplate<T,H>::CClientClientDHTTemplate(const MPI_Comm& clientIntraComm)
+CClientClientDHTTemplate<T,H>::CClientClientDHTTemplate(const ep_lib::MPI_Comm& clientIntraComm)
   : H(clientIntraComm), index2InfoMapping_(), indexToInfoMappingLevel_(), nbClient_(0)
 {
@@ -34,5 +38,5 @@
 template<typename T, typename H>
 CClientClientDHTTemplate<T,H>::CClientClientDHTTemplate(const Index2InfoTypeMap& indexInfoMap,
-                                                        const MPI_Comm& clientIntraComm)
+                                                        const ep_lib::MPI_Comm& clientIntraComm)
   : H(clientIntraComm), index2InfoMapping_(), indexToInfoMappingLevel_(), nbClient_(0)
 {
@@ -59,5 +63,5 @@
 template<typename T, typename H>
 CClientClientDHTTemplate<T,H>::CClientClientDHTTemplate(const Index2VectorInfoTypeMap& indexInfoMap,
-                                                        const MPI_Comm& clientIntraComm)
+                                                        const ep_lib::MPI_Comm& clientIntraComm)
   : H(clientIntraComm), index2InfoMapping_(), indexToInfoMappingLevel_(), nbClient_(0)
 {
@@ -95,5 +99,5 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::computeIndexInfoMappingLevel(const CArray<size_t,1>& indices,
-                                                                 const MPI_Comm& commLevel,
+                                                                 const ep_lib::MPI_Comm& commLevel,
                                                                  int level)
 {
@@ -169,5 +173,5 @@
     recvIndexBuff = new unsigned long[recvNbIndexCount];
 
-  std::vector<MPI_Request> request;
+  std::vector<ep_lib::MPI_Request> request;
   std::vector<int>::iterator itbRecvIndex = recvRankClient.begin(), itRecvIndex,
                              iteRecvIndex = recvRankClient.end(),
@@ -179,5 +183,7 @@
   {
     if (0 != recvNbIndexClientCount[idx])
+    {
       recvIndexFromClients(recvRankClient[idx], recvIndexBuff+currentIndex, recvNbIndexClientCount[idx], commLevel, request);
+    }
     currentIndex += recvNbIndexClientCount[idx];
   }
@@ -188,5 +194,5 @@
     sendIndexToClients(itIndex->first, (itIndex->second), sendNbIndexBuff[itIndex->first-groupRankBegin], commLevel, request);
 
-  std::vector<MPI_Status> status(request.size());
+  std::vector<ep_lib::MPI_Status> status(request.size());
   MPI_Waitall(request.size(), &request[0], &status[0]);
 
@@ -242,5 +248,5 @@
   }
 
-  std::vector<MPI_Request> requestOnReturn;
+  std::vector<ep_lib::MPI_Request> requestOnReturn;
   currentIndex = 0;
   for (int idx = 0; idx < recvRankOnReturn.size(); ++idx)
@@ -293,5 +299,5 @@
   }
 
-  std::vector<MPI_Status> statusOnReturn(requestOnReturn.size());
+  std::vector<ep_lib::MPI_Status> statusOnReturn(requestOnReturn.size());
   MPI_Waitall(requestOnReturn.size(), &requestOnReturn[0], &statusOnReturn[0]);
 
@@ -360,5 +366,5 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::computeDistributedIndex(const Index2VectorInfoTypeMap& indexInfoMap,
-                                                            const MPI_Comm& commLevel,
+                                                            const ep_lib::MPI_Comm& commLevel,
                                                             int level)
 {
@@ -412,5 +418,4 @@
     {
       client2ClientIndex[indexClient + groupRankBegin][sendNbIndexBuff[indexClient]] = it->first;;
-  //          ProcessDHTElement<InfoType>::packElement(it->second, client2ClientInfo[indexClient + groupRankBegin], sendNbInfo[indexClient]);
       ProcessDHTElement<InfoType>::packElement(infoTmp[idx], client2ClientInfo[indexClient + groupRankBegin], sendNbInfo[indexClient]);
       ++sendNbIndexBuff[indexClient];
@@ -439,5 +444,5 @@
   // it will send a message to the correct clients.
   // Contents of the message are index and its corresponding informatioin
-  std::vector<MPI_Request> request;
+  std::vector<ep_lib::MPI_Request> request;
   int currentIndex = 0;
   int nbRecvClient = recvRankClient.size();
@@ -458,11 +463,18 @@
                                                 iteIndex = client2ClientIndex.end();
   for (itIndex = itbIndex; itIndex != iteIndex; ++itIndex)
+  {
     sendIndexToClients(itIndex->first, itIndex->second, sendNbIndexBuff[itIndex->first-groupRankBegin], commLevel, request);
+  }
+
   boost::unordered_map<int, unsigned char*>::iterator itbInfo = client2ClientInfo.begin(), itInfo,
                                                       iteInfo = client2ClientInfo.end();
   for (itInfo = itbInfo; itInfo != iteInfo; ++itInfo)
+  {
     sendInfoToClients(itInfo->first, itInfo->second, sendNbInfo[itInfo->first-groupRankBegin], commLevel, request);
 
-  std::vector<MPI_Status> status(request.size());
+  }
+
+  std::vector<ep_lib::MPI_Status> status(request.size());
+
   MPI_Waitall(request.size(), &request[0], &status[0]);
 
@@ -518,8 +530,8 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::sendIndexToClients(int clientDestRank, size_t* indices, size_t indiceSize,
-                                                       const MPI_Comm& clientIntraComm,
-                                                       std::vector<MPI_Request>& requestSendIndex)
-{
-  MPI_Request request;
+                                                       const ep_lib::MPI_Comm& clientIntraComm,
+                                                       std::vector<ep_lib::MPI_Request>& requestSendIndex)
+{
+  ep_lib::MPI_Request request;
   requestSendIndex.push_back(request);
   MPI_Isend(indices, indiceSize, MPI_UNSIGNED_LONG,
@@ -536,8 +548,8 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::recvIndexFromClients(int clientSrcRank, size_t* indices, size_t indiceSize,
-                                                         const MPI_Comm& clientIntraComm,
-                                                         std::vector<MPI_Request>& requestRecvIndex)
-{
-  MPI_Request request;
+                                                         const ep_lib::MPI_Comm& clientIntraComm,
+                                                         std::vector<ep_lib::MPI_Request>& requestRecvIndex)
+{
+  ep_lib::MPI_Request request;
   requestRecvIndex.push_back(request);
   MPI_Irecv(indices, indiceSize, MPI_UNSIGNED_LONG,
@@ -555,10 +567,9 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::sendInfoToClients(int clientDestRank, unsigned char* info, int infoSize,
-                                                      const MPI_Comm& clientIntraComm,
-                                                      std::vector<MPI_Request>& requestSendInfo)
-{
-  MPI_Request request;
+                                                      const ep_lib::MPI_Comm& clientIntraComm,
+                                                      std::vector<ep_lib::MPI_Request>& requestSendInfo)
+{
+  ep_lib::MPI_Request request;
   requestSendInfo.push_back(request);
-
   MPI_Isend(info, infoSize, MPI_CHAR,
             clientDestRank, MPI_DHT_INFO, clientIntraComm, &(requestSendInfo.back()));
@@ -575,8 +586,8 @@
 template<typename T, typename H>
 void CClientClientDHTTemplate<T,H>::recvInfoFromClients(int clientSrcRank, unsigned char* info, int infoSize,
-                                                        const MPI_Comm& clientIntraComm,
-                                                        std::vector<MPI_Request>& requestRecvInfo)
-{
-  MPI_Request request;
+                                                        const ep_lib::MPI_Comm& clientIntraComm,
+                                                        std::vector<ep_lib::MPI_Request>& requestRecvInfo)
+{
+  ep_lib::MPI_Request request;
   requestRecvInfo.push_back(request);
 
@@ -651,6 +662,6 @@
 {
   recvNbElements.resize(recvNbRank.size());
-  std::vector<MPI_Request> request(sendNbRank.size()+recvNbRank.size());
-  std::vector<MPI_Status> requestStatus(sendNbRank.size()+recvNbRank.size());
+  std::vector<ep_lib::MPI_Request> request(sendNbRank.size()+recvNbRank.size());
+  std::vector<ep_lib::MPI_Status> requestStatus(sendNbRank.size()+recvNbRank.size());
 
   int nRequest = 0;
@@ -696,6 +707,6 @@
   std::vector<int> recvBuff(recvBuffSize*2,0);
 
-  std::vector<MPI_Request> request(sendBuffSize+recvBuffSize);
-  std::vector<MPI_Status> requestStatus(sendBuffSize+recvBuffSize);
+  std::vector<ep_lib::MPI_Request> request(sendBuffSize+recvBuffSize);
+  std::vector<ep_lib::MPI_Status> requestStatus(sendBuffSize+recvBuffSize);
 
   int nRequest = 0;
@@ -721,5 +732,8 @@
   }
 
+  //MPI_Barrier(this->internalComm_);
+
   MPI_Waitall(sendBuffSize+recvBuffSize, &request[0], &requestStatus[0]);
+
   int nbRecvRank = 0, nbRecvElements = 0;
   recvNbRank.clear();
Index: /XIOS/dev/branch_yushan_merged/src/client_server_mapping.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/client_server_mapping.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/client_server_mapping.hpp	(revision 1134)
@@ -14,4 +14,8 @@
 #include "mpi.hpp"
 #include <boost/unordered_map.hpp>
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios {
@@ -37,5 +41,5 @@
 
     static std::map<int,int> computeConnectedClients(int nbServer, int nbClient,
-                                                     MPI_Comm& clientIntraComm,
+                                                     ep_lib::MPI_Comm& clientIntraComm,
                                                      const std::vector<int>& connectedServerRank);
 
Index: /XIOS/dev/branch_yushan_merged/src/client_server_mapping_distributed.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/client_server_mapping_distributed.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/client_server_mapping_distributed.hpp	(revision 1134)
@@ -35,5 +35,5 @@
     /** Default constructor */
     CClientServerMappingDistributed(const boost::unordered_map<size_t,int>& globalIndexOfServer,
-                                    const MPI_Comm& clientIntraComm,
+                                    const ep_lib::MPI_Comm& clientIntraComm,
                                     bool isDataDistributed = true);
 
Index: /XIOS/dev/branch_yushan_merged/src/context_client.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/context_client.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/context_client.cpp	(revision 1134)
@@ -20,5 +20,5 @@
     \cxtSer [in] cxtSer Pointer to context of server side. (It is only used on case of attached mode)
     */
-    CContextClient::CContextClient(CContext* parent, MPI_Comm intraComm_, MPI_Comm interComm_, CContext* cxtSer)
+    CContextClient::CContextClient(CContext* parent, ep_lib::MPI_Comm intraComm_, ep_lib::MPI_Comm interComm_, CContext* cxtSer)
      : mapBufferSize_(), parentServer(cxtSer), maxBufferedEvents(4)
     {
@@ -291,6 +291,10 @@
        if (ratio < minBufferSizeEventSizeRatio) minBufferSizeEventSizeRatio = ratio;
      }
+     #ifdef _usingMPI
      MPI_Allreduce(MPI_IN_PLACE, &minBufferSizeEventSizeRatio, 1, MPI_DOUBLE, MPI_MIN, intraComm);
-
+     #elif _usingEP
+     MPI_Allreduce(&minBufferSizeEventSizeRatio, &minBufferSizeEventSizeRatio, 1, MPI_DOUBLE, MPI_MIN, intraComm);
+     #endif
+     
      if (minBufferSizeEventSizeRatio < 1.0)
        ERROR("void CContextClient::setBufferSize(const std::map<int,StdSize>& mapSize, const std::map<int,StdSize>& maxEventSize)",
@@ -392,9 +396,9 @@
      for (itMap = itbMap; itMap != iteMap; ++itMap)
      {
-       report(10) << " Memory report : Context <" << context->getId() << "> : client side : memory used for buffer of each connection to server" << endl
-                  << "  +) To server with rank " << itMap->first << " : " << itMap->second << " bytes " << endl;
+       //report(10) << " Memory report : Context <" << context->getId() << "> : client side : memory used for buffer of each connection to server" << endl
+       //           << "  +) To server with rank " << itMap->first << " : " << itMap->second << " bytes " << endl;
        totalBuf += itMap->second;
      }
-     report(0) << " Memory report : Context <" << context->getId() << "> : client side : total memory used for buffer " << totalBuf << " bytes" << endl;
+     //report(0) << " Memory report : Context <" << context->getId() << "> : client side : total memory used for buffer " << totalBuf << " bytes" << endl;
 
      releaseBuffers();
Index: /XIOS/dev/branch_yushan_merged/src/context_client.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/context_client.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/context_client.hpp	(revision 1134)
@@ -27,5 +27,5 @@
     public:
       // Contructor
-      CContextClient(CContext* parent, MPI_Comm intraComm, MPI_Comm interComm, CContext* parentServer = 0);
+      CContextClient(CContext* parent, ep_lib::MPI_Comm intraComm, ep_lib::MPI_Comm interComm, CContext* parentServer = 0);
 
       // Send event to server
@@ -67,7 +67,7 @@
       int serverSize; //!< Size of server group
 
-      MPI_Comm interComm; //!< Communicator of server group
+      ep_lib::MPI_Comm interComm; //!< Communicator of server group
 
-      MPI_Comm intraComm; //!< Communicator of client group
+      ep_lib::MPI_Comm intraComm; //!< Communicator of client group
 
       map<int,CClientBuffer*> buffers; //!< Buffers for connection to servers
Index: /XIOS/dev/branch_yushan_merged/src/context_server.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/context_server.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/context_server.cpp	(revision 1134)
@@ -10,5 +10,5 @@
 #include "file.hpp"
 #include "grid.hpp"
-#include "mpi.hpp"
+#include "mpi_std.hpp"
 #include "tracer.hpp"
 #include "timer.hpp"
@@ -23,5 +23,5 @@
 {
 
-  CContextServer::CContextServer(CContext* parent,MPI_Comm intraComm_,MPI_Comm interComm_)
+  CContextServer::CContextServer(CContext* parent, ep_lib::MPI_Comm intraComm_, ep_lib::MPI_Comm interComm_)
   {
     context=parent;
@@ -72,5 +72,5 @@
     int count;
     char * addr;
-    MPI_Status status;
+    ep_lib::MPI_Status status;
     map<int,CServerBuffer*>::iterator it;
 
@@ -80,5 +80,5 @@
       {
         traceOff();
-        MPI_Iprobe(rank,20,interComm,&flag,&status);
+        ep_lib::MPI_Iprobe(rank,20,interComm,&flag,&status);
         traceOn();
         if (flag==true)
@@ -88,5 +88,5 @@
           {
             StdSize buffSize = 0;
-            MPI_Recv(&buffSize, 1, MPI_LONG, rank, 20, interComm, &status);
+            ep_lib::MPI_Recv(&buffSize, 1, MPI_LONG, rank, 20, interComm, &status);
             mapBufferSize_.insert(std::make_pair(rank, buffSize));
             it=(buffers.insert(pair<int,CServerBuffer*>(rank,new CServerBuffer(buffSize)))).first;
@@ -94,9 +94,10 @@
           else
           {
-            MPI_Get_count(&status,MPI_CHAR,&count);
+            
+            ep_lib::MPI_Get_count(&status,MPI_CHAR,&count);
             if (it->second->isBufferFree(count))
             {
               addr=(char*)it->second->getBuffer(count);
-              MPI_Irecv(addr,count,MPI_CHAR,rank,20,interComm,&pendingRequest[rank]);
+              ep_lib::MPI_Irecv(addr,count,MPI_CHAR,rank,20,interComm,&pendingRequest[rank]);
               bufferRequest[rank]=addr;
             }
@@ -109,5 +110,5 @@
   void CContextServer::checkPendingRequest(void)
   {
-    map<int,MPI_Request>::iterator it;
+    map<int,ep_lib::MPI_Request>::iterator it;
     list<int> recvRequest;
     list<int>::iterator itRecv;
@@ -115,16 +116,16 @@
     int flag;
     int count;
-    MPI_Status status;
-
-    for(it=pendingRequest.begin();it!=pendingRequest.end();it++)
+    ep_lib::MPI_Status status;
+
+    for(it=pendingRequest.begin();it!=pendingRequest.end();++it)
     {
       rank=it->first;
       traceOff();
-      MPI_Test(& it->second, &flag, &status);
+      ep_lib::MPI_Test(& it->second, &flag, &status);
       traceOn();
       if (flag==true)
       {
         recvRequest.push_back(rank);
-        MPI_Get_count(&status,MPI_CHAR,&count);
+        ep_lib::MPI_Get_count(&status,MPI_CHAR,&count);
         processRequest(rank,bufferRequest[rank],count);
       }
@@ -219,4 +220,5 @@
     {
       finished=true;
+      #pragma omp critical (_output)
       info(20)<<"Server Side context <"<<context->getId()<<"> finalized"<<endl;
       std::map<int, StdSize>::const_iterator itbMap = mapBufferSize_.begin(),
@@ -225,10 +227,10 @@
       for (itMap = itbMap; itMap != iteMap; ++itMap)
       {
-        report(10)<< " Memory report : Context <"<<context->getId()<<"> : server side : memory used for buffer of each connection to client" << endl
-                  << "  +) With client of rank " << itMap->first << " : " << itMap->second << " bytes " << endl;
+        //report(10)<< " Memory report : Context <"<<context->getId()<<"> : server side : memory used for buffer of each connection to client" << endl
+        //          << "  +) With client of rank " << itMap->first << " : " << itMap->second << " bytes " << endl;
         totalBuf += itMap->second;
       }
       context->finalize();
-      report(0)<< " Memory report : Context <"<<context->getId()<<"> : server side : total memory used for buffer "<<totalBuf<<" bytes"<<endl;
+      //report(0)<< " Memory report : Context <"<<context->getId()<<"> : server side : total memory used for buffer "<<totalBuf<<" bytes"<<endl;
     }
     else if (event.classId==CContext::GetType()) CContext::dispatchEvent(event);
Index: /XIOS/dev/branch_yushan_merged/src/context_server.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/context_server.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/context_server.hpp	(revision 1134)
@@ -14,5 +14,5 @@
     public:
 
-    CContextServer(CContext* parent,MPI_Comm intraComm,MPI_Comm interComm) ;
+    CContextServer(CContext* parent, ep_lib::MPI_Comm intraComm, ep_lib::MPI_Comm interComm) ;
     bool eventLoop(bool enableEventsProcessing = true);
     void listen(void) ;
@@ -25,13 +25,13 @@
     bool hasFinished(void);
 
-    MPI_Comm intraComm ;
+    ep_lib::MPI_Comm intraComm ;
     int intraCommSize ;
     int intraCommRank ;
 
-    MPI_Comm interComm ;
+    ep_lib::MPI_Comm interComm ;
     int commSize ;
 
     map<int,CServerBuffer*> buffers ;
-    map<int,MPI_Request> pendingRequest ;
+    map<int,ep_lib::MPI_Request> pendingRequest ;
     map<int,char*> bufferRequest ;
 
Index: /XIOS/dev/branch_yushan_merged/src/cxios.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/cxios.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/cxios.cpp	(revision 1134)
@@ -14,17 +14,30 @@
 namespace xios
 {
-  string CXios::rootFile="./iodef.xml" ;
-  string CXios::xiosCodeId="xios.x" ;
-  string CXios::clientFile="./xios_client";
-  string CXios::serverFile="./xios_server";
+
+  extern int test_omp_rank;
+  #pragma omp threadprivate(test_omp_rank)
+
+  const string CXios::rootFile="./iodef.xml" ;
+  const string CXios::xiosCodeId="xios.x" ;
+  const string CXios::clientFile="./xios_client";
+  const string CXios::serverFile="./xios_server";
+
 
   bool CXios::isClient ;
   bool CXios::isServer ;
+
+
   MPI_Comm CXios::globalComm ;
+
+  
   bool CXios::usingOasis ;
   bool CXios::usingServer = false;
+
+
   double CXios::bufferSizeFactor = 1.0;
   const double CXios::defaultBufferSizeFactor = 1.0;
   StdSize CXios::minBufferSize = 1024 * sizeof(double);
+
+
   bool CXios::printLogs2Files;
   bool CXios::isOptPerformance = true;
@@ -36,5 +49,11 @@
   {
     set_new_handler(noMemory);
-    parseFile(rootFile);
+    
+    
+    #pragma omp critical
+    {
+      parseFile(rootFile);  
+    }
+    #pragma omp barrier
     parseXiosConfig();
   }
@@ -68,5 +87,35 @@
       ERROR("CXios::parseXiosConfig()", "recv_field_timeout cannot be negative.");
 
-    globalComm=MPI_COMM_WORLD ;
+ 
+    int num_ep;
+    if(isClient)  
+    { 
+      num_ep = omp_get_num_threads();
+    }
+    
+    if(isServer) 
+    { 
+      num_ep = omp_get_num_threads();
+    }
+    
+    MPI_Info info;
+    #pragma omp master
+    {
+      MPI_Comm *ep_comm;
+      MPI_Comm_create_endpoints(MPI_COMM_WORLD, num_ep, info, ep_comm);  // servers should reach here too.
+      passage = ep_comm;  
+    }
+    
+    #pragma omp barrier
+
+      
+    CXios::globalComm = passage[omp_get_thread_num()];
+
+    int tmp_rank;
+    MPI_Comm_rank(CXios::globalComm, &tmp_rank);
+
+    
+    test_omp_rank = tmp_rank;
+    
   }
 
@@ -79,9 +128,10 @@
   void CXios::initClientSide(const string& codeId, MPI_Comm& localComm, MPI_Comm& returnComm)
   {
+    isClient = true;
+    
     initialize() ;
 
-    isClient = true;
-
     CClient::initialize(codeId,localComm,returnComm) ;
+
     if (CClient::getRank()==0) globalRegistry = new CRegistry(returnComm) ;
 
@@ -92,4 +142,5 @@
     if (printLogs2Files)
     {
+      #pragma omp critical
       CClient::openInfoStream(clientFile);
       CClient::openErrorStream(clientFile);
@@ -107,4 +158,5 @@
      if (CClient::getRank()==0)
      {
+       #pragma omp critical (_output)
        info(80)<<"Write data base Registry"<<endl<<globalRegistry->toString()<<endl ;
        globalRegistry->toFile("xios_registry.bin") ;
@@ -123,4 +175,15 @@
   void CXios::initServer()
   {
+    int initialized;
+    MPI_Initialized(&initialized);
+    if (initialized) CServer::is_MPI_Initialized=true ;
+    else CServer::is_MPI_Initialized=false ;
+      
+ 
+    if(!CServer::is_MPI_Initialized)
+    {
+      MPI_Init(NULL, NULL);
+    }
+      
     set_new_handler(noMemory);
     std::set<StdString> parseList;
@@ -133,8 +196,11 @@
   void CXios::initServerSide(void)
   {
-    initServer();
+    
     isClient = false;
     isServer = true;
-
+    
+    initServer();
+    
+    
     // Initialize all aspects MPI
     CServer::initialize();
@@ -162,5 +228,7 @@
        delete globalRegistry ;
      }
+
     CServer::finalize();
+        
     CServer::closeInfoStream();
   }
Index: /XIOS/dev/branch_yushan_merged/src/cxios.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/cxios.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/cxios.hpp	(revision 1134)
@@ -5,4 +5,5 @@
 #include "mpi.hpp"
 #include "registry.hpp"
+#include "log.hpp"
 
 namespace xios
@@ -14,37 +15,43 @@
   {
     public:
-     static void initialize(void) ;
-     static void initClientSide(const string & codeId, MPI_Comm& localComm, MPI_Comm& returnComm) ;
-     static void initServerSide(void) ;
-     static void clientFinalize(void) ;
-     static void parseFile(const string& filename) ;
+      static void initialize(void) ;
+      static void initClientSide(const string & codeId, ep_lib::MPI_Comm& localComm, ep_lib::MPI_Comm& returnComm) ;
+      static void initServerSide(void) ;
+      static void clientFinalize(void) ;
+      static void parseFile(const string& filename) ;
 
-     template <typename T>
-     static T getin(const string& id,const T& defaultValue) ;
+      template <typename T>
+      static T getin(const string& id,const T& defaultValue) ;
 
-     template <typename T>
-     static T getin(const string& id) ;
+      template <typename T>
+      static T getin(const string& id) ;
 
     public:
-     static string rootFile ; //!< Configuration filename
-     static string xiosCodeId ; //!< Identity for XIOS
-     static string clientFile; //!< Filename template for client
-     static string serverFile; //!< Filename template for server
+      static const string rootFile; //!< Configuration filename
+      static const string xiosCodeId ; //!< Identity for XIOS
+      static const string clientFile; //!< Filename template for client
+      static const string serverFile; //!< Filename template for server
 
-     static bool isClient ; //!< Check if xios is client
-     static bool isServer ; //!< Check if xios is server
+      static bool isClient ; //!< Check if xios is client
+      static bool isServer ; //!< Check if xios is server
+      #pragma omp threadprivate(isClient, isServer)
 
-     static MPI_Comm globalComm ; //!< Global communicator
+      static MPI_Comm globalComm ; //!< Global communicator
+      #pragma omp threadprivate(globalComm)
 
-     static bool printLogs2Files; //!< Printing out logs into files
-     static bool usingOasis ; //!< Using Oasis
-     static bool usingServer ; //!< Using server (server mode)
-     static double bufferSizeFactor; //!< Factor used to tune the buffer size
-     static const double defaultBufferSizeFactor; //!< Default factor value
-     static StdSize minBufferSize; //!< Minimum buffer size
-     static bool isOptPerformance; //!< Check if buffer size is for performance (as large as possible)
-     static CRegistry* globalRegistry ; //!< global registry which is wrote by the root process of the servers
-     static double recvFieldTimeout; //!< Time to wait for data before issuing an error when receiving a field
-
+      static bool printLogs2Files; //!< Printing out logs into files
+      static bool usingOasis ; //!< Using Oasis
+      static bool usingServer ; //!< Using server (server mode)
+      static double bufferSizeFactor; //!< Factor used to tune the buffer size
+      static const double defaultBufferSizeFactor; //!< Default factor value
+      static StdSize minBufferSize; //!< Minimum buffer size
+      static bool isOptPerformance; //!< Check if buffer size is for performance (as large as possible)
+      #pragma omp threadprivate(printLogs2Files, usingOasis, usingServer, bufferSizeFactor, minBufferSize, isOptPerformance)
+      
+      static CRegistry* globalRegistry ; //!< global registry which is wrote by the root process of the servers
+      static double recvFieldTimeout;
+      #pragma omp threadprivate(recvFieldTimeout)
+      
+      
     public:
      //! Setting xios to use server mode
Index: /XIOS/dev/branch_yushan_merged/src/dht_auto_indexing.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/dht_auto_indexing.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/dht_auto_indexing.cpp	(revision 1134)
@@ -22,5 +22,5 @@
 
   CDHTAutoIndexing::CDHTAutoIndexing(const CArray<size_t,1>& hashValue,
-                                     const MPI_Comm& clientIntraComm)
+                                     const ep_lib::MPI_Comm& clientIntraComm)
     : CClientClientDHTTemplate<size_t>(clientIntraComm)
   {
@@ -58,5 +58,5 @@
   */
   CDHTAutoIndexing::CDHTAutoIndexing(Index2VectorInfoTypeMap& hashInitMap,
-                                     const MPI_Comm& clientIntraComm)
+                                     const ep_lib::MPI_Comm& clientIntraComm)
     : CClientClientDHTTemplate<size_t>(clientIntraComm)
   {
Index: /XIOS/dev/branch_yushan_merged/src/dht_auto_indexing.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/dht_auto_indexing.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/dht_auto_indexing.hpp	(revision 1134)
@@ -12,4 +12,7 @@
 
 #include "client_client_dht_template.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
 
 namespace xios
@@ -25,8 +28,8 @@
 
     CDHTAutoIndexing(const CArray<size_t,1>& hashValue,
-                     const MPI_Comm& clientIntraComm);
+                     const ep_lib::MPI_Comm& clientIntraComm);
 
     CDHTAutoIndexing(Index2VectorInfoTypeMap& hashInitMap,
-                     const MPI_Comm& clientIntraComm);
+                     const ep_lib::MPI_Comm& clientIntraComm);
 
     size_t getNbIndexesGlobal() const;
Index: /XIOS/dev/branch_yushan_merged/src/event_scheduler.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/event_scheduler.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/event_scheduler.cpp	(revision 1134)
@@ -132,9 +132,17 @@
     while(received)
     {
+      #ifdef _usingEP
+      MPI_Iprobe(-1,1,communicator,&received, &status) ;
+      #else
       MPI_Iprobe(MPI_ANY_SOURCE,1,communicator,&received, &status) ;
+      #endif
       if (received)
       {
         recvRequest=new SPendingRequest ;
+        #ifdef _usingEP
+        MPI_Irecv(recvRequest->buffer, 3, MPI_UNSIGNED_LONG, -1, 1, communicator, &(recvRequest->request)) ;
+        #else
         MPI_Irecv(recvRequest->buffer, 3, MPI_UNSIGNED_LONG, MPI_ANY_SOURCE, 1, communicator, &(recvRequest->request)) ;
+        #endif
         pendingRecvParentRequest.push(recvRequest) ;
       }
@@ -174,9 +182,17 @@
     while(received)
     {
+      #ifdef _usingEP
+      MPI_Iprobe(-1,0,communicator,&received, &status) ;
+      #else
       MPI_Iprobe(MPI_ANY_SOURCE,0,communicator,&received, &status) ;
+      #endif
       if (received)
       {
         recvRequest=new SPendingRequest ;
+        #ifdef _usingEP
+        MPI_Irecv(recvRequest->buffer, 3, MPI_UNSIGNED_LONG, -1, 0, communicator, &recvRequest->request) ;
+        #else
         MPI_Irecv(recvRequest->buffer, 3, MPI_UNSIGNED_LONG, MPI_ANY_SOURCE, 0, communicator, &recvRequest->request) ;
+        #endif
         pendingRecvChildRequest.push_back(recvRequest) ;
       }
Index: /XIOS/dev/branch_yushan_merged/src/event_scheduler.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/src/event_scheduler.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/src/event_scheduler.hpp	(revision 1134)
@@ -4,4 +4,8 @@
 #include "xios_spl.hpp"
 #include "mpi.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
+
 
 namespace xios
